/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... ukazatele a funkce, puleni intervalu
*/

#include<iostream>
#include<iomanip>
using namespace std;

/* Ukazka funkce bez parametru, ktera vraci ukazatel:
   funkce vraci adresu nove vytvorene dynamicke 
   promenne typu int. */
int* funkce()
{
	int *x =  new int;
	*x = 5;
	return x;
}

/* Ukazka funkce bez parametru, ktera vraci hodnotu:
   funkce vraci hodnotu typu int. */
int funkce1()
{
	int x = 5;
	return x;
}

int secti(int a, int b)
{
	return a + b;
}

int odecti(int a, int b)
{
	return a - b;
}

double f1(double x)
{
	return tan(x) - x;
}

double f2(double x)
{
	return sqrt(x+2) - 2;
}

void priklad1()
{
	// deklarace ukazatele
	int (*f) (int, int);
	void (*g) (int*, int&, bool);
	int* (*h) (void);

	// prirazeni hodnoty
	f = secti;
	// f = &secti;

	// volani funkce
	int x = f(1, 4);
	//int x = (*f)(1, 4);
	cout << x << endl;

	f = odecti;
	x = f(1, 4);
	cout << x << endl;

	// deklarace pole ukazatelu na funkce
	double(*pole[5])(double);
	double(*pole1[])(double) = { sin, log, cos };
	pole[0] = sin;
	pole[1] = cos;
	pole[2] = tan;
	pole[3] = log;
	cout << pole[0](3.14) << endl;
	cout << pole[2](3.14) << endl;
}

double puleniIntervalu(double(*F)(double), double a, double b, double eps)
{
	while (abs(a - b) > eps)
	{
		double x = (a + b) / 2;
		/* if (abs(F(x)) < eps)
			return x;
		*/
		if (F(x) * F(a) <= 0)
			b = x;
		else
			a = x;
	}
	return (a + b) / 2;   // return a;
}

void priklad2()
{
	double eps = 0.000001;
	double v = puleniIntervalu(f1, 3.142 / 2, 3 * 3.14 / 2, eps);
	cout << "x= " << v << " f1(x)= " << f1(v) << endl;
	v = puleniIntervalu(f2, -2, 5, eps);
	cout << "x= " << v << " f2(x)= " << f1(v) << endl;
}

int main()
{
	priklad1();
	priklad2();
	return 0;
}

